<template>
	<div>
		<CommonHeader :setOrden="true" :showIcon="true" :showBackButton="true" :title="$t('personalData')"></CommonHeader>
		<HeaderProfile></HeaderProfile>
		<div class="secction-formulario">
			<span class="missing-info" v-if="missingData">{{ $t('missingData') }}</span>
			<form class="form-crear">
				<div class="form-group">
					<label>{{$t('firstName')}}</label>
					<input v-model=formData.name />
					<span v-if="formErrors.name" class="error">{{ $t('nameError') }}</span>
				</div>
				<div class="form-group">
					<label>{{$t('email')}} </label>
					<input v-model="formData.email" />
					<span v-if="formErrors.email" class="error">{{ $t('correoError') }}</span>
				</div>
				<div class="form-group">
					<label>{{$t('telephone')}} </label>
					<input v-model="formData.phone" />
					<span v-if="formErrors.phone" class="error">{{ $t('telephoneLengthError') }}</span>
					<span v-if="formErrors.phoneRepeat" class="error">{{ $t('telephoneRepeatError') }}</span>
				</div>
			</form>
		</div>
		<div class="secction-button">
			<button @click="cancel()"> {{$t('cancel')}}  </button>
			<AjaxButton class="final-button" :loading="loading" :text="$t('updateData')" @click="updateData()"></AjaxButton>
		</div>
	</div>
</template>

<script lang="ts">
import { Component, Vue } from 'vue-property-decorator'
import CommonHeader from '@/components/CommonHeader.vue'
import HeaderProfile from '@/components/HeaderProfile.vue'
import AjaxButton from '@/components/AjaxButton.vue'
import {updateUser} from '@/services/UserService'
import { User } from '@/models/User'
@Component({
	components: {
		CommonHeader,
		HeaderProfile,
		AjaxButton,
	},
})
export default class PersonalInfoEdit extends Vue {

	loading = false
	user = this.$store.state.user as User
	error: undefined | string = undefined
	missingData = false

	formData = {
		name: '',
		email: '',
		phone: ''
	}

	formErrors = {
		name: false,
		email: false,
		phone: false,
		phoneRepeat: false
	};

	async updateData(){
		if (!this.validForm()) return;
		const update = await updateUser(this.user, this.formData.name, this.formData.email, this.formData.phone, this.user.authToken)
		if(update) {
			await this.$store.dispatch('login', update);
			await this.$router.back();
		}
	}

	validForm(){
		this.formErrors = {name: false, email: false, phone: false, phoneRepeat: false}
		if(!this.formData.name) this.formErrors.name = true
		if(!this.formData.email) this.formErrors.email = true
		if(this.formData.phone.length !== 10) this.formErrors.phone = true
		if(this.checkDigitRepeated(this.formData.phone, 5)) this.formErrors.phoneRepeat = true
		for (const error of Object.values(this.formErrors)) {
			if (error == true) return false;
		}
		return true
	}

	checkDigitRepeated(input: string, repeat: number){
		const regex = new RegExp("(\\d)\\1{" + repeat + "}", "g");
		return !!input.match(regex);
	}

	created(){
		this.formData.name = this.user.name
		this.formData.email = this.user.email
		this.formData.phone = this.user.phone
		if ( !this.formData.name || !this.formData.email || !this.formData.phone){
			this.missingData = true
		}
	}


	cancel(){
		this.$router.push('/personalinfo')
	}
}
</script>
<style lang="scss" scoped>
p {
	margin: 0;
}
.menu {
	padding: 0 1em;
	div {
		margin: 1em 0;
		display: flex;
		justify-content: space-between;
		align-items: baseline;
		p {
			color: rgba(117, 112, 112, 1);
			font-size: 1em;
			font-weight: 400;
			line-height: 24px;
		}
		span {
			font-weight: 400;
			font-size: 1.5em;
			color: rgba(100, 105, 121, 1);
		}
	}
}
.secction-formulario {
	padding: 1em;
	.missing-info{
		font-weight: bold;
		color: red;
	}
	.form-crear {
		label {
			font-size: 1em;
			color: rgba(117, 112, 112, 1);
			margin-bottom: 0.4em;
		}
		.form-group {
			display: grid;
			margin: 1em 0;

			input {
				border-radius: 7px;
				border: 0.5px solid rgba(192, 192, 192, 1);
				padding: 0.8em 0.8em 0.8em 10px;
				color: rgba(0, 0, 0, 1);
			}
			input::-webkit-input-placeholder {
				color: rgba(0, 0, 0, 1);
				font-size: 1.2em;
			}

			.error {
				font-size: 12px;
				color: red;
				margin: auto;
			}
		}
	}
}
.secction-button {
    padding: 0 1em;
	button {
		background: rgba(236, 97, 134, 1);
		color: white;
		border: 1px solid #ec6186;
		border-radius: 6px;
		width: 28%;
		height: 46px;
        float:left;
        font-weight: 500;
        font-size: 1.15em;
	}
	.final-button {
        float:right;
		width: 68%;
	}
}
</style>